<template>
  <v-layout color="#f8f8f8">
    <v-flex md12 pa-1>
      <v-layout>
        <v-card class="mx-auto my-12" elevation="0" width="100%" height="100%">
          <v-layout wrap>
            <v-flex xs8>
              <div class="font-size-24-bold title-style">
                Admin Management
              </div>
            </v-flex>
            <v-spacer></v-spacer>
            <v-flex
              xs3
              style="margin: 16px 8px 16px 0px;font-family: Sarabun, sans-serif;"
            >
              <v-text-field
                outline
                placeholder="Search"
                name="search"
                v-model="searchadmin"
                append-icon="search"
                style="width:100%"
              >
              </v-text-field>
            </v-flex>
          </v-layout>

          <v-layout>
            <v-flex
              style="display: flex;justify-content: flex-end;margin-right: 32px;"
            >
              <!-- add admin dialog -->
              <v-dialog v-model="dialog" persistent max-width="400px">
                <template v-slot:activator="{ on, attrs }">
                  <v-btn class="btn-add" v-bind="attrs" v-on="on">
                    <v-icon light left>mdi-account-plus</v-icon>Add Admin
                  </v-btn>
                </template>
                <v-card>
                  <v-form v-model="isFormValid">
                    <v-card-title>
                      <v-icon style="margin-right:10px; color:#58a144;">
                        mdi-account-plus
                      </v-icon>
                      <span class="title">Add Admin</span>
                    </v-card-title>
                    <v-card-text>
                      <v-container>
                        <v-layout wrap>
                          <v-flex xs12>
                            <v-text-field
                              outline
                              ref="addmail"
                              name="addmail"
                              append-icon="mdi-email"
                              v-model="addmail"
                              placeholder="E-mail"
                              style="font-family: Sarabun, sans-serif;"
                              :rules="[
                                () => !!addmail || 'This field is required'
                              ]"
                            ></v-text-field>
                          </v-flex>
                        </v-layout>
                      </v-container>
                    </v-card-text>
                    <v-card-actions>
                      <v-spacer></v-spacer>
                      <v-btn
                        outline
                        class="btn-close"
                        text
                        @click="dialog = false"
                      >
                        Cancle
                      </v-btn>

                      <v-btn
                        class="btn-save"
                        text
                        @click="onSave()"
                        :disabled="!isFormValid"
                      >
                        Save
                      </v-btn>
                    </v-card-actions>
                  </v-form>
                </v-card>
              </v-dialog>
            </v-flex>
          </v-layout>

          <v-flex md12 pa-1>
            <v-data-table
              :rows-per-page-items="rowperpage"
              :pagination.sync="pagination"
              :headers="headers"
              :items="adminlist"
              class="elevation-0 custom-table-cell table-style"
              :search="searchadmin"
              disable-initial-sort
              id="mytable"
            >
              <template v-slot:items="props">
                <td class="text-xs-center">{{ props.index + 1 }}</td>
                <td class="text-xs-left">{{ props.item.name }}</td>
                <td class="text-xs-left">{{ props.item.email }}</td>
                <td class="justify-center layout px-0">
                  <v-icon
                    small
                    color="#F4D03F"
                    class="mr-2"
                    @click="editItem(props.item.email, props.item.role)"
                  >
                    edit
                  </v-icon>
                  <v-icon
                    small
                    color="red"
                    @click="dialogDel(props.item.email)"
                  >
                    delete
                  </v-icon>
                </td>
              </template>
            </v-data-table>
          </v-flex>
        </v-card>
      </v-layout>

      <div>
        <!-- edit dialog -->
        <v-dialog v-model="dialogEdit" max-width="400px">
          <v-card>
            <v-form v-model="isFormValid">
              <v-card-title>
                <v-icon style="margin-right:10px; color:#F4D03F;">
                  mdi-pencil
                </v-icon>
                <span class="title">Edit Admin</span>
              </v-card-title>
              <v-card-text>
                <v-container>
                  <v-layout wrap>
                    <v-flex xs12>
                      <v-text-field
                        outline
                        ref="editmail"
                        name="editmail"
                        append-icon="mdi-email"
                        v-model="editmail"
                        placeholder="E-mail"
                        style="font-family: Sarabun, sans-serif;"
                        :rules="[() => !!editmail || 'This field is required']"
                      ></v-text-field>
                    </v-flex>
                  </v-layout>
                </v-container>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn
                  outline
                  class="btn-close"
                  text
                  @click="dialogEdit = false"
                >
                  Cancle
                </v-btn>

                <v-btn
                  class="btn-save"
                  text
                  @click="onEdit()"
                  :disabled="!isFormValid"
                >
                  Save
                </v-btn>
              </v-card-actions>
            </v-form>
          </v-card>
        </v-dialog>

        <!-- delete dialog -->
        <v-dialog v-model="dialogConfirm" max-width="400px">
          <v-card>
            <v-card-title>
              <v-icon style="margin-right:10px; color:#d1392b;"
                >mdi-delete
              </v-icon>
              <span class="title">Delete Admin</span>
            </v-card-title>
            <v-card-text>
              <v-container grid-list-md>
                <v-layout wrap>
                  <v-flex
                    xs12
                    style="background-color:#FEE3E3; color:red;font-family: Sarabun, sans-serif;"
                  >
                    <v-icon color="red">mdi-alert</v-icon>
                    You may be deleting user data. <br />
                    After you delete this, it can't be recovered.
                  </v-flex>
                </v-layout>
              </v-container>
            </v-card-text>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn
                class="btn-cancel-delete"
                flat
                @click="dialogConfirm = false"
                >Cancel</v-btn
              >
              <v-btn class="btn-delete" @click="deleteItem">Delete</v-btn>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </div>
    </v-flex>
  </v-layout>
</template>

<script>
import moment from "moment";
import Swal from "sweetalert2";

moment.locale("en");
export default {
  data() {
    return {
      dialog: false,
      dialogEdit: false,
      dialogConfirm: false,
      addmail: "",
      editmail: "",
      currentdata: {},
      deleteemail: "",
      searchadmin: "",
      adminlist: [],
      headers: [
        { text: "No.", align: "center", sortable: false, value: "no" },
        { text: "Name", align: "left", value: "name" },
        { text: "E-mail", align: "left", value: "email" },
        { text: "Action", align: "center", value: "action", sortable: false }
      ],
      editedItem: {
        email: "",
        role: ""
      },
      defaultItem: {
        email: "",
        role: "admin"
      },
      isFormValid: false,
      rowperpage: [
        5,
        10,
        25,
        { text: "$vuetify.dataIterator.rowsPerPageAll", value: -1 }
      ],
      pagination: {
        rowsPerPage: 10
      }
    };
  },
  methods: {
    clearForm() {
      Object.keys(this.form).forEach(f => {
        this.$refs[f].reset();
      });
    },
    async checkField() {
      this.formHasErrors = false;
      Object.keys(this.form).forEach(f => {
        if (!this.form[f]) this.formHasErrors = true;
        this.dialogloader = false;
        this.$refs[f].validate(true);
      });
    },
    handleView() {
      this.mobileView = window.innerWidth <= 990;
    },
    async getAdminList() {
      try {
        this.istableloading = true;
        var { data } = await this.axios.get(
          `${process.env.VUE_APP_APIHOST}/admin_management`,
          {
            headers: {
              Authorization: this.$cookies.get("token")
            }
          }
        );
        this.adminlist = data;
        this.istableloading = false;
      } catch (error) {
        this.istableloading = false;
        console.log(error.message);
      }
    },
    editItem(email, role) {
      this.currentdata = { email: email, role: role };
      this.editmail = this.currentdata.email;
      this.dialogEdit = true;
    },
    async dialogDel(email) {
      this.deleteemail = email;
      this.dialogConfirm = true;
    },
    close() {
      this.clearForm();
      this.dialog = false;
      setTimeout(() => {
        this.editedItem = Object.assign({}, this.defaultItem);
        this.editedIndex = -1;
      }, 300);
    },
    async onSave() {
      this.istableloading = true;
      await this.checkField();
      if (this.formHasErrors == false) {
        let { data } = await this.axios.post(
          `${process.env.VUE_APP_APIHOST}/admin_add`,
          {
            email: this.addmail
          },
          {
            headers: { Authorization: this.$cookies.get("token") }
          }
        );
        if (data === "Success") {
          Swal.fire({
            title: "Add Successful",
            text: "",
            icon: "success",
            showConfirmButton: false
          });
          setTimeout(() => {
            window.location.reload();
          }, 1500);
        } else {
          Swal.fire({
            title: "Error",
            text: "",
            icon: "error"
          }).then(function() {
            window.location.reload();
          });
        }
      }
    },
    async onEdit() {
      this.istableloading = true;
      let { data } = await this.axios.post(
        `${process.env.VUE_APP_APIHOST}/admin_edit`,
        {
          past_email: this.currentdata.email,
          email: this.editmail,
          editBy: this.$cookies.get("firstlastTH")
        },
        {
          headers: { Authorization: this.$cookies.get("token") }
        }
      );
      if (data === "Success") {
        Swal.fire({
          title: "Edit Successful",
          text: "",
          icon: "success",
          showConfirmButton: false
        });
        setTimeout(() => {
          window.location.reload();
        }, 1500);
      } else {
        Swal.fire({
          title: "Error",
          text: "",
          icon: "error"
        }).then(function() {
          window.location.reload();
        });
      }
    },
    async deleteItem() {
      this.istableloading = true;
      let { data } = await this.axios.post(
        `${process.env.VUE_APP_APIHOST}/admin_del`,
        {
          email: this.deleteemail
        },
        {
          headers: { Authorization: this.$cookies.get("token") }
        }
      );
      if (data === "Success") {
        Swal.fire({
          title: "Delete Successful",
          text: "",
          icon: "success",
          showConfirmButton: false
        });
        setTimeout(() => {
          window.location.reload();
        }, 1500);
      } else {
        Swal.fire({
          title: "Error",
          text: "",
          icon: "error"
        }).then(function() {
          window.location.reload();
        });
      }
    }
  },
  created() {
    this.getAdminList();
    this.handleView();
    window.addEventListener("resize", this.handleView);
  },
  computed: {
    form() {
      return {
        addmail: this.addmail
      };
    }
  },
  watch: {
    dialog(val) {
      val || this.close();
    }
  }
};
</script>

<style scoped>
.btn-add {
  font-weight: bold;
  line-height: 24px;
  text-align: center;
  background-color: #58a144 !important;
  color: white;
  border-radius: 4px;
  font-family: "Sarabun", sans-serif;
}

.title {
  font-weight: bold;
  font-size: 26px !important;
  font-family: "Sarabun", sans-serif !important;
}

.btn-close {
  font-weight: bold;
  line-height: 24px;
  text-align: center;
  color: #d1392b;
  border-radius: 4px;
  text-transform: none;
}

.btn-save {
  background-color: #58a144 !important;
  color: white;
  font-weight: bold;
  font-size: 16px;
  line-height: 24px;
  text-align: center;
  border-radius: 4px;
  text-transform: none;
  font-family: "Sarabun", sans-serif;
}

.btn-delete {
  background-color: #d1392b !important;
  color: white;
  font-weight: bold;
  font-size: 16px;
  line-height: 24px;
  text-align: center;
  border-radius: 4px;
  text-transform: none;
  font-family: "Sarabun", sans-serif;
}

.btn-cancel-delete {
  font-weight: bold;
  line-height: 24px;
  text-align: center;
  color: #000;
  border-radius: 4px;
  text-transform: none;
  font-family: "Sarabun", sans-serif;
}
</style>
